

var q = null
var lib = null
var main = null

var timeoutInterval = 90000
 

function escapeHTML(text) {
    return text.replace(/&/g, '&amp;')
               .replace(/</g, '&lt;')
               .replace(/>/g, '&gt;');
}

function appendText(txt, elemType) {
   var textElem = document.createElement(elemType)
   var txtNode = document.createTextNode(escapeHTML(txt))
   textElem.appendChild(txtNode)
   document.body.appendChild(textElem)
}

function charAsInt(charString) {
    return charString.charCodeAt(0)
}

function intAsChar(num) {
    return String.fromCharCode(num)
}

function println(txt, color, elemType) {
    if (color === undefined) {color = "black"}
    document.body.innerHTML = document.body.innerHTML +
        '<span style="color: ' + color + '">' + 
         escapeHTML(txt) + '</span><br/> \n'   
}

function launch(func) {setTimeout(func, timeoutInterval)}

function catchTimeout(vow, message, millis, testFunc) {
    var resolved = false
    if (vow === null || vow === undefined) {
        println("null vow catchtimeout: " + message, "red")   
    } else {
        q.when(vow,
            function(answer) {
                resolved = true
                if (testFunc === undefined) {
                    println("untested success: " + message, "green")
                } else if (testFunc(answer)) {
                    println("Fulfilled and passed test: " + message, "green")
                } else {println("Fulfilled but failed test: " + 
                    message + "value: " + JSON.stringify(answer), "red")
                }
                
            },
            function(err) {
                //println("Err on: " + message + " " + err.toJSONString(), "red")
                println("err on: " + message + " " + JSON.stringify(err), "red")
                resolved = true
            }
        ) 
    }
    function printTimedOut() {
        if (!resolved) {println("Failed timeout on: " + message, "red")}
    }
    setTimeout(printTimedOut, millis)  
}

function nullcatch(message, vow) {
    catchTimeout(vow, "nullcatch returned value for: " + message, timeoutInterval)
    return vow   
}

function errcatch(message, vow) {
    catchTimeout(vow, "errcatch zero length string for: " + message, timeoutInterval, function(err) {
        return err.length === 0
    })
    return vow
}

function printHelp_(obj, label) { 
    //obj.post("postHelp",[]).when(
    
    q.when(q.post(obj,"postHelp",[]),
        function(data){
            println(label, "blue");
            println(data, "blue")
            //println (obj.toJSONString(), "blue")
            println(lib.web._url(obj), "blue")
            //println(obj["@"])
        },
        function (err){
            println("postHelp failed: " + label + err, "red")
        }
    )
}

function printVow(objVow, label) {
	//objVow.when(
    q.when(objVow,
		function(obj) {
			println(label, "blue");
			//println(obj.toJSONString(), "blue")
            //println(JSON.stringify(obj), "blue")
            println(lib.web._url(obj))
		},
		function (err) {
            println("printSoon reject: " + label + err + " : " +JSON.stringify(err), "red")
		}
	)
}

function testFileContent(fileMarker, message, intendedContent) {
    //var dataVow = q.get(fileMarker,"bytes")
    var dataVow = q.get(fileMarker, "string")
    catchTimeout(dataVow, message, timeoutInterval, function(data) {
        if (intendedContent.length != data.length) {
            println("file length mismatch", "red");return false
        }
        for (i = 0; i < data.length; i++) {
            if (intendedContent[i] != data[i]) {
                println("file char mismatch, intended: " +
                    intendedContent + "   |actual: " + data, "red")
                return false
            }   
        }
        return true
    })
}

function doMain(theLib) {
    lib = theLib
    q = lib.Q
    main = lib.web.getLocation()
    var killPollerQuick = false
    var fredReg = null
    var fredUrl = null
    //var fredUrl = "https://y-z5erpuzhjqkgsvlg.yurl.net:8443/-/fredreg%0D/#52fq2qdhrvhbmy"
    //var fredUrl = "https://y-oscffr2av6yu6fnv.yurl.net:9443/-/fredreg/#sxveaeov5y256l"
    fredUrl = "https://sha-256-3jjotownaeom6cax.yurl.net:8444/-/fred/#s=6c2w6kgeulbxgq"

    function makeBoxPair(name1, name2) {
        
        var answer = {}
        var pal1pair = q.defer()
        var box1 = q.post(main,"makeMailbox", [name1])
        q.post(box1,"setFred", [fredReg])
        var notifier = lib.web._ref( null,
            "https://y-oscffr2av6yu6fnv.yurl.net:9443/-/mailnotifier/#4cjt5l72fhk4a4")
        q.post(box1,"setMailNotifier", [notifier])
        q.post(box1,"setNotificationAddress", ["marc.d.stiegler@hp.com"])
        printHelp_(box1, name1)
        var box2 = q.post(main,"makeMailbox", [name2])
        q.post(box2,"setFred", [fredReg])
        printHelp_(box2, name2)
        
        var pal1name = name1+"Pal"
        var pal2name = name2+"Pal"
        
        var b1ReceiverVow = q.post(box1,"makeReceiveFacetForNewPet_", [pal2name])
        var pal2 = q.post(q.get(box1,"palsMgr"),"getPalFromPetname", [pal2name])
        q.when(b1ReceiverVow,function(b1receiver) {
            pal1 = q.post(box2,"addPalFromSendTarget", [b1receiver])
            nullcatch("pal1 in makeboxpair", pal1)
            // is it a refsend bug that i must do this?
            q.when(pal1,function(pal) {pal1pair.resolve(pal)})
            q.post(pal1,"setPetname", [pal1name])  
            println(pal1name + " petname set")      
        })
        catchTimeout(b1ReceiverVow, "receiver for " + name1, timeoutInterval)
        
        answer[name1]=box1
        answer[name2]=box2
        answer[pal1name] = pal1pair.promise
        answer[pal2name] = pal2
        return answer
    }

    function makeFile(box, path, content) {
        var filepair = q.defer()
        var fileMarkerSummVow = nullcatch(path,q.post(box,"tempFileMarkerFromPath", [path]))
        //fileMarkerSummVow.when(function(summ) {
        q.when(fileMarkerSummVow, function(summ) {
            var marker = summ.fileMarker
            filepair.resolve(marker)
            q.post(marker,"setString", [content])
            testFileContent(marker, "set file " + path, content)
        })
        return filepair.promise
    }

    function withInSumm(message, box, i, act) {
        //nullcatch("withinsumm: " + message, box.get("inboxSummaries")).when(function(summs) {
        var inboxVow = q.get(box, "inboxSummaries")
        nullcatch("withinsumm: " + message, inboxVow)
        q.when(inboxVow, 
            function(summs) {
            if (summs.length < i+1) {
                println("withInSumm bad index: " + i, "red")
            } else {
                act(summs[i])   
            }  
        })   
    }

    function exercise() {    
        println("Into scoopfsMain", "green")
        document.title = "SCoopFS Regression Test"
        printHelp_(main, "main")
        println("beyond main printhelp")
        if (fredUrl === null) {
            fredRegVow = q.post(main,"makeFred", [])
            println("sent make fred")
            //fredRegVow.when(function(fred) {
            q.when(fredRegVow, function(fred) {
                println("got fred")
                fredReg = fred
                exerciseAfterFredMade()
            }, function(err) {println("making fred err: " + JSON.stringify(err), "red")})
            println("fred when passes syntax check")
        } else {
            fredReg = lib.web._ref(null, fredUrl) 
            exerciseAfterFredMade()
        }
        println("got to end of exercise, awaiting fred resolution")
        
    }

    function exerciseAfterFredMade() {    
        
        println("into exercise after fred made")
        // create alice mailbox and set her nickname
        var abboxes = makeBoxPair("alice", "bob")
        var aliceBox = abboxes["alice"]
        var alicePal = abboxes["alicePal"]
        q.post(aliceBox,'setNickname', ['alice box'])
        q.post(aliceBox,'pingWeb', [])
        var nameVow = q.get(aliceBox,"nickname")
        catchTimeout(nameVow, "alices new nickname", timeoutInterval,
            function(name) {return name === "alice box"})
        var bobBox = abboxes["bob"] 
           
        catchTimeout(q.get(abboxes["alicePal"],("petname")), "alicepetpetname", timeoutInterval,
            function(name){return name === "alicePal"})
            
        var bobInAliceBox = abboxes["bobPal"]
        
        // create bob, carol, ted mailboxes
        var ctboxes = makeBoxPair("carol","ted")
        var carolBox = ctboxes["carol"]
        var tedBox = ctboxes["ted"]
        var carolPal = ctboxes["carolPal"]
        var tedPal = ctboxes["tedPal"]
        
        // shut off the poller, this is a temp test
        //bobBox.post("killPoller", [])
        //carolBox.post("killPoller", [])
        //tedBox.post("killPoller", [])
        if (killPollerQuick) {q.post(aliceBox,"killPoller", [])}
        
        // reset the testing files
        var aFileMarker = makeFile(aliceBox, "aliceRegression.txt", "a")
        var bFileMarker = makeFile(bobBox, "bobRegression.txt", "b")
        var cFileMarker = makeFile(carolBox, "carolR.txt", "carol")
        var c2FileMarker = makeFile(carolBox, "carol2R.txt", "carol2v1")
        var tFileMarker = makeFile(tedBox, "tedR.txt", "ted")
        var t2FileMarker = makeFile(tedBox, "ted2R.txt", "ted2v1")
        
        var carolSharedFile = null
        var carol2SharedFile = null
        var ted2SharedFile = null
        
        //set autosend, autorecv, both ways
        q.post(alicePal,"setAutoSend", [true])
        q.post(alicePal,"setAutoRecv", [true])
        catchTimeout(q.get(alicePal,"autoSend"), "autoSendSet on alicepal", timeoutInterval, 
            function(answer) {return answer})
        q.post(bobInAliceBox,"setAutoSend", [true])
        q.post(bobInAliceBox,"setAutoRecv", [true])
        var isAutoRecv = q.get(bobInAliceBox,"autoRecv")
        catchTimeout(isAutoRecv, "autoRecvSet on bobpal", timeoutInterval, 
            function(answer) {return answer})
        
        // alice send bob mail no attach
        //println("alice about to send message no attach")
        //bobInAliceBox.when(function(bobPet) {
        q.when(bobInAliceBox,function(bobPet) {
            q.post(aliceBox,"sendMessage", [bobInAliceBox, "toBob", "from alice", null])
        })
        
        // bob send alice mail with attach
        //alicePal.when(function(apal) {
        q.when(alicePal,function(apal) {
            q.post(bobBox,"sendSyncedFileMessage", [apal, 
                "b1", "b1body", "bobRegression.txt",
                true, true])
        })
        
        q.when(carolPal,function (carolp) {
            q.post(tedBox,"sendSyncedFileMessage", [carolp,
                "t2", "t2body", "ted2R.txt", true, true]) 
            //nullcatch("tedShareSums", tedBox.get("sharedFileSummaries")).when(function(summs) {
            var tedSharesVow = q.get(tedBox,"sharedFileSummaries")
            nullcatch("tedShareSums", tedSharesVow)
            q.when(tedSharesVow, 
                function(summs) {
                if (summs.length != 1) {
                    println("ted shares not 1", "red")
                } else {
                    ted2SharedFile = summs[0].sharedFile   
                }
            })
        })

        q.when(tedPal,function(tedp) {
            var err = q.post(carolBox,"sendSyncedFileMessage", [tedp, 
                "c1", "c1body", "carolR.txt",
                true, true])
        })
        
        // after 20 sec
        function phase2() {
            println ("--")
            println("phase2 begins")
            println("file marker jsoned: " + JSON.stringify(aFileMarker))
            println("file marker _urled:" + lib.web._url(aFileMarker))
            var aSvrMgr = q.get(aliceBox,"svrMgr")
            printVow(aSvrMgr, "alice svrmgr")
            var aforwarder = q.get(aSvrMgr,"forwarder")
            printVow(aforwarder, "alice forwarder")
            //println(afile.toJSONString())
            //println("bad afile", "red")
            // see if bob got one message no attachment
            var bobSummariesVow = q.get(bobBox,"inboxSummaries")
            catchTimeout(bobSummariesVow, "bobMessageSummaries1", timeoutInterval,
                function(summaries) {
                    var result = summaries.length === 1 &&
                        summaries[0].subject === "toBob" &&
                        summaries[0].body === "from alice" &&
                        summaries[0].isMail && summaries[0].attachmentIDs === undefined
                    return result
                }
            )
            
            // see if alice got one message one attach        
            var aliceSummariesVow = q.get(aliceBox,"inboxSummaries")
            catchTimeout(aliceSummariesVow, "aliceMessageSummaries1", timeoutInterval,
                function(summaries) {
                    var result = summaries.length === 1 &&
                        summaries[0].subject === "b1" &&
                        summaries[0].body === "b1body" &&
                        summaries[0].isMail 
                    return result
                }
            )
            
            // alice save file
            q.when(aliceSummariesVow,function(summaries) {
                if (summaries.length > 0) {
                    var id = summaries[0].attachmentIDs[0]
                    println("attach id: " + id, "blue")
                    var err = q.post(aliceBox,"saveSyncAttachment", [summaries[0].message,
                    summaries[0].attachmentIDs[0], aFileMarker])
                    catchTimeout(err, "alice save sync", 10000)
                    testFileContent(aFileMarker, "alice save of bob attach worked", "b")
                    
                    
                    // alice modify file
                    q.post(aFileMarker,"setString", ["c"])
                    testFileContent(aFileMarker, "alice mod of bob attach before send", "c")
                    catchTimeout(q.get(aliceBox,"syncs"), "getsyncs finds change", 
                        timeoutInterval, function(checker) {
                        return checker.length > 0
                    }) 
                    q.post(aliceBox,"checkSyncs", [])
                } else {println("alice did not receive mail", "red")}   
            })
            
            // ted save file
            var tedSummariesVow = q.get(tedBox,"inboxSummaries")
            catchTimeout(tedSummariesVow, "tedSummaries having received email", 
                timeoutInterval, function(summaries) {            
                return summaries.length === 1
            })
            q.when(tedSummariesVow,function (summaries) {
                if (summaries.length === 1) {
                    println("ted 1 mail received", "green")
                    var err = q.post(tedBox,"saveSyncAttachment", [summaries[0].message,
                        summaries[0].attachmentIDs[0], tFileMarker])
                } else {println("ted no carol mail", "red")}
                testFileContent(tFileMarker, "ted save carol attach", "carol")  
            })
            
            
            // carol queue 2 updates to ted, then commit to propagate, testing send queues
            q.post(cFileMarker,"setString", ["carolv2"])
            q.post(carolBox,"checkSyncs", [])
            q.post(cFileMarker,"setString", ["carolv3"])
            q.post(carolBox,"checkSyncs", [])
            q.when(q.get(carolBox,"sharedFileSummaries"),function(fileSummaries) {
                if (fileSummaries.length != 1) {
                    println("carol bad file summs length", "red")
                } else {
                    carolSharedFile = fileSummaries[0].sharedFile
                    q.post(carolSharedFile,"commitLocalChanges", [])
                }
            })
            
            // carol save ted2 file        
            q.when(q.get(carolBox,"inboxSummaries"),function(summaries) {
                if (summaries.length === 1) {
                    println("carol 1 mail received", "green")
                    errcatch("carol1savesync",q.post(carolBox,"saveSyncAttachment", [summaries[0].message,
                    summaries[0].attachmentIDs[0], c2FileMarker]))
                    q.when(nullcatch("carolFileSums", q.get(carolBox, "sharedFileSummaries")),
                    //nullcatch("carolFileSums",q.when(q.get(carolBox,"sharedFileSummaries"),
                        function(fileSummaries) {
                            if (fileSummaries.length != 2) {
                                println("carol not 2 sharedfiles", "red")
                            } else {
                                println("carol filesummaries length 2", "green")
                                carol2SharedFile = fileSummaries[1].sharedFile                            
                            } 
                        }
                    )
                    //)
                } else { println("carol no tedmail", "red")}
                testFileContent(c2FileMarker, "carol save ted attach", "ted2v1")
            })
            launch(phase3)
        }
        setTimeout(phase2, 3*timeoutInterval)
        
        // phase 3 later
        function phase3() {
            println("-- phase 3 -- ")
            var summariesVow = q.get(bobBox,"inboxSummaries")
            catchTimeout(summariesVow, "bobMessageSummariesPhase3", timeoutInterval,
                function(summaries) {
                    var result = false
                    if (summaries.length != 2) {
                        println("wrong num summaries bobbox: " + summaries.length, "red")
                        result = false
                    } else {
                        var update = summaries[1]
                        if (!update.isMail && !update.hasConflict && update.hasBeenUsed) {
                            println("update to bob looks good", "green")
                            result = true 
                        } else {
                            println("update to bob screwy", "red")  
                            result = false
                        } 
                        testFileContent(bFileMarker, "bobFileUpdated", "c")
                    }
                    return result
                }
            )
            
            // does ted have the update in his inbox?
            q.when(q.get(tedBox,"inboxSummaries"),function(tedSummaries) {
                if (tedSummaries.length != 2) {
                    println("ted inbox not 1 mail 1 update", "red")
                }  else {
                    var goodUpdate = tedSummaries[1].isMail === false &&
                        tedSummaries[1].hasConflict === false &&
                        tedSummaries[1].hasBeenUsed === false
                    if (goodUpdate) {
                        println("ted update1 is good", "green")
                    } else {println("tedupdate1 bad", "red") }     
                }
            }, function(err) {println("bad ted inbox", "red")})
            
            // carol send yet another update, testing receive queueing
            q.post(cFileMarker,"setString", ["carolv4"])
            q.post(carolBox,"checkSyncs", [])
            q.post(carolSharedFile,"commitLocalChanges", [])
            launch(phase4)
        }
        //setTimeout(phase3, 40000)
        
        function phase4() {
            println("--")
            println("phase 4")
            q.when(q.get(tedBox,"inboxSummaries"),function(tedSummaries) {
                if (tedSummaries.length != 2) {
                    println("ted inbox2 not 1 mail 1 update", "red")
                }  else {
                    var goodUpdate = tedSummaries[1].isMail === false &&
                        tedSummaries[1].hasConflict === false &&
                        tedSummaries[1].hasBeenUsed === false
                    if (goodUpdate) {
                        println("ted update2 quickcheck good", "green")
                        errcatch("tedupdate", 
                            q.when(q.get(tedSummaries[1].message,"receivedUpdate").post(
                            "update", [])),function(done) {
                                testFileContent(tFileMarker, "ted 3rd update", "carolv4")
                            })
                    } else {println("tedupdate2 bad", "red") }     
                }
            }, function(err) {println("bad ted inbox", "red")})
            
            // carol and ted both edit ted2r, detect and resolve conflict
            q.post(t2FileMarker,"setString", "ted2v2")
            q.post(c2FileMarker,"setString", "carol2v2")
            q.post(tedBox,"checkSyncs", [])
            q.post(carolBox,"checkSyncs", [])
            q.post(carol2SharedFile,"commitLocalChanges", [])
            q.post(ted2SharedFile,"commitLocalChanges", [])
            launch(phase5)
        }
        //setTimeout(phase4, 55000)
        
        function phase5() {
            println("-- phase 5 -- ")
            withInSumm("carol conflict ted2", carolBox, 1, function(updateSumm) {
                var goodUpdate = !updateSumm.isMail && !hasBeenUsed && hasConflict
                if (goodUpdate) {
                    println("got carol2 conflict", "green")
                } else {
                    println("bad carol2 update")
                } 
            })
            
        }
        //setTimeout(phase5, 70000)
        
    } 

    var launchClassVow = q.post(main, "postHelp",[])
    q.when(launchClassVow, function(launchClass) {
            //alert("got help" + launchClass)
            if (launchClass.indexOf("Main") >=0 ) {
                println("about to run regression")
                exercise()
            } else if (launchClass.indexOf("ReceiveFacet") >= 0) {
                showReceiveFacetHelp()
            } else if (launchClass.indexOf("Mailbox") >= 0) {
                runBox()
            } else {alert("This url is assigned to an unidentified object")}
        },
        function(err) {
            alert("bad main page url")
        }
    )   
}

function showReceiveFacetHelp() {
    document.title = "SCoopFS Pal Webkey"
    document.body.innerHTML = '<h2>Pal Webkey</h2>' +
        '<p>This link goes to a Pal webkey (technically, a ReceiveFacetX).' +
        ' If you received this webkey from a potential Pal, go into SCoopFS, ' +
        ' go to the Pals tab, create a new Pal with pal name, and use this ' +
        ' webkey as the address for the pal.</p>' +
        '<p>If you just created this webkey for a pal, give the pal this webkey, ' +
        'and show them the instructions provided above.</p>'
}


