function escapeHTML(text) {
    return text.replace(/&/g, '&amp;')
               .replace(/</g, '&lt;')
               .replace(/>/g, '&gt;');
}

function appendText(txt, elemType) {
   var textElem = document.createElement(elemType)
   var txtNode = document.createTextNode(txt)
   textElem.appendChild(txtNode)
   document.body.appendChild(textElem)
}

function charAsInt(charString) {
    return charString.charCodeAt(0)
}

function intAsChar(num) {
    return String.fromCharCode(num)
}

function println(txt, color, elemType) {
    if (color === undefined) {color = "black"}
    document.body.innerHTML = document.body.innerHTML +
        '<span style="color: ' + color + '">' + 
         txt + '</span><br/> \n'   
}

var timeoutInterval = 120000
var killPollerQuick = true
var fredReg = null
//var fredUrl = "https://y-z5erpuzhjqkgsvlg.yurl.net:8443/-/fredreg%0D/#52fq2qdhrvhbmy"
var fredUrl = null

function launch(func) {setTimeout(func, timeoutInterval)}

function catchTimeout(vow, message, millis, testFunc) {
    var resolved = false
    if (vow === null || vow === undefined) {
        println("null vow catchtimeout: " + message, "red")   
    } else {
        vow.when(
            function(answer) {
                resolved = true
                if (testFunc === undefined) {
                    println("untested success: " + message, "green")
                } else if (testFunc(answer)) {
                    println("Fulfilled and passed test: " + message, "green")
                } else {println("Fulfilled but failed test: " + 
                    message + " value: " + answer.toJSONString(), "red")
                }
                
            },
            function(err) {
                println("Err on: " + message + " " + err.toJSONString(), "red")
                resolved = true
            }
        ) 
    }
    function printTimedOut() {
        if (!resolved) {println("Failed timeout on: " + message, "red")}
    }
    setTimeout(printTimedOut, millis)  
}

function nullcatch(message, vow) {
    catchTimeout(vow, "nullcatch returned value for: " + message, timeoutInterval)
    return vow   
}

function errcatch(message, vow) {
    catchTimeout(vow, "errcatch zero length string for: " + message, timeoutInterval, function(err) {
        return err.length === 0
    })
    return vow
}

function printHelp_(obj, label) {
    obj.post("postHelp",[]).when(
        function(data){
            println(label, "blue");
            println(data, "blue")
            println (obj.toJSONString(), "blue")
            //println(obj["@"])
        },
        function e(err){
            println("postHelp failed: " + label + err, "red")
        }
    )
}

function testFileContent(fileMarker, message, intendedContent) {
    var dataVow = fileMarker.get("bytes")
    catchTimeout(dataVow, message, timeoutInterval, function(data) {
        if (intendedContent.length != data.length) {return false}
        for (i = 0; i < data.length; i++) {
            if (intendedContent.charCodeAt(i) != data[i]) {return false}   
        }
        return true
    })
}

function makeBoxPair(name1, name2) {
    
    var answer = {}
    var pal1pair = _.defer()
    var box1 = main.post("makeMailbox", [name1])
	box1.post("setFred", [fredReg])
    printHelp_(box1, name1)
    var box2 = main.post("makeMailbox", [name2])
	box2.post("setFred", [fredReg])
    printHelp_(box2, name2)
    
    var pal1name = name1+"Pal"
    var pal2name = name2+"Pal"
    
    var b1ReceiverVow = box1.post("makeReceiveFacetForNewPet_", [pal2name])
    var pal2 = box1.get("palsMgr").post("getPalFromPetname", [pal2name])
    b1ReceiverVow.when(function(b1receiver) {
        pal1 = box2.post("addPalFromSendTarget", [b1receiver])
        nullcatch("pal1 in makeboxpair", pal1)
        // is it a refsend bug that i must do this?
        pal1.when(function(pal) {pal1pair.resolver.fulfill(pal)})
        pal1.post("setPetname", [pal1name])  
        println(pal1name + " petname set")      
    })
    catchTimeout(b1ReceiverVow, "receiver for " + name1, timeoutInterval)
    
    answer[name1]=box1
    answer[name2]=box2
    answer[pal1name] = pal1pair.promise
    answer[pal2name] = pal2
    return answer
}

function makeFile(box, path, content) {
    var filepair = _.defer()
    var fileMarkerSummVow = nullcatch(path,box.post("tempFileMarkerFromPath", [path]))
    fileMarkerSummVow.when(function(summ) {
        var marker = summ.fileMarker
        filepair.resolver.fulfill(marker)
        marker.post("setString", [content])
        testFileContent(marker, "set file " + path, content)
    })
    return filepair.promise
}

function withInSumm(message, box, i, act) {
    nullcatch("withinsumm: " + message, box.get("inboxSummaries")).when(function(summs) {
        if (summs.length < i+1) {
            println("withInSumm bad index: " + i, "red")
        } else {
            act(summs[i])   
        }  
    })   
}

function exercise() {    
    println("Into scoopfsMain", "green")
    var main = _.connect(window.location.toString())
    printHelp_(main, "main")
	if (fredUrl === null) {
	fredRegVow = main.post("makeFred", [])
		fredRegVow.when(function(fred) {
			println("got fred")
			fredReg = fred
			exerciseAfterFredMade()
		})
	} else {
		fredReg = _.connect(fredUrl)
		exerciseAfterFredMade()
	}
	
}

function exerciseAfterFredMade() {    
    
    
    // create alice mailbox and set her nickname
    var abboxes = makeBoxPair("alice", "bob")
    var aliceBox = abboxes["alice"]
    var alicePal = abboxes["alicePal"]
    aliceBox.post('setNickname', ['alice box'])
    var nameVow = aliceBox.get("nickname")
    catchTimeout(nameVow, "alices new nickname", timeoutInterval,
        function(name) {return name === "alice box"})
    var bobBox = abboxes["bob"] 
       
    catchTimeout(abboxes["alicePal"].get("petname"), "alicepetpetname", timeoutInterval,
        function(name){return name === "alicePal"})
        
    var bobInAliceBox = abboxes["bobPal"]
    
    // create bob, carol, ted mailboxes
    var ctboxes = makeBoxPair("carol","ted")
    var carolBox = ctboxes["carol"]
    var tedBox = ctboxes["ted"]
    var carolPal = ctboxes["carolPal"]
    var tedPal = ctboxes["tedPal"]
	
	// shut off the poller, this is a temp test
	bobBox.post("killPoller", [])
	carolBox.post("killPoller", [])
	tedBox.post("killPoller", [])
    if (killPollerQuick) {aliceBox.post("killPoller", [])}
	
    // reset the testing files
    var aFileMarker = makeFile(aliceBox, "aliceRegression.txt", "a")
    var bFileMarker = makeFile(bobBox, "bobRegression.txt", "b")
    var cFileMarker = makeFile(carolBox, "carolR.txt", "carol")
    var c2FileMarker = makeFile(carolBox, "carol2R.txt", "carol2v1")
    var tFileMarker = makeFile(tedBox, "tedR.txt", "ted")
    var t2FileMarker = makeFile(tedBox, "ted2R.txt", "ted2v1")
    
    var carolSharedFile = null
    var carol2SharedFile = null
    var ted2SharedFile = null
    
    //set autosend, autorecv, both ways
    alicePal.post("setAutoSend", [true])
    alicePal.post("setAutoRecv", [true])
    catchTimeout(alicePal.get("autoSend"), "autoSendSet on alicepal", timeoutInterval, 
        function(answer) {return answer})
    bobInAliceBox.post("setAutoSend", [true])
    bobInAliceBox.post("setAutoRecv", [true])
    var isAutoRecv = bobInAliceBox.get("autoRecv")
    catchTimeout(isAutoRecv, "autoRecvSet on bobpal", timeoutInterval, 
        function(answer) {return answer})
    
    // alice send bob mail no attach
    //println("alice about to send message no attach")
    bobInAliceBox.when(function(bobPet) {
        aliceBox.post("sendMessage", [bobInAliceBox, "toBob", "from alice", null])
    })
    
    // bob send alice mail with attach
    alicePal.when(function(apal) {
        bobBox.post("sendSyncedFileMessage", [apal, 
			"b1", "b1body", "bobRegression.txt",
			true, true])
    })
    
    carolPal.when(function (carolp) {
        tedBox.post("sendSyncedFileMessage", [carolp,
            "t2", "t2body", "ted2R.txt", true, true]) 
        nullcatch("tedShareSums", tedBox.get("sharedFileSummaries")).when(function(summs) {
            if (summs.length != 1) {
                println("ted shares not 1", "red")
            } else {
                ted2SharedFile = summs[0].sharedFile   
            }
        })
    })

    tedPal.when(function(tedp) {
        var err = carolBox.post("sendSyncedFileMessage", [tedp, 
			"c1", "c1body", "carolR.txt",
			true, true])
    })
    
    // after 20 sec
    function phase2() {
        println ("--")
        println("phase2 begins")
        println("file marker: " + aFileMarker.toJSONString())
        //println(afile.toJSONString())
        //println("bad afile", "red")
        // see if bob got one message no attachment
        var bobSummariesVow = bobBox.get("inboxSummaries")
        catchTimeout(bobSummariesVow, "bobMessageSummaries1", timeoutInterval,
            function(summaries) {
                var result = summaries.length === 1 &&
                    summaries[0].subject === "toBob" &&
                    summaries[0].body === "from alice" &&
                    summaries[0].isMail && summaries[0].attachmentIDs === undefined
                return result
            }
        )
        
        // see if alice got one message one attach        
        var aliceSummariesVow = aliceBox.get("inboxSummaries")
        catchTimeout(aliceSummariesVow, "aliceMessageSummaries1", timeoutInterval,
            function(summaries) {
                var result = summaries.length === 1 &&
                    summaries[0].subject === "b1" &&
                    summaries[0].body === "b1body" &&
                    summaries[0].isMail 
                return result
            }
        )
        
        // alice save file
        aliceSummariesVow.when(function(summaries) {
            if (summaries.length > 0) {
                var id = summaries[0].attachmentIDs[0]
                println("attach id: " + id, "blue")
                var err = aliceBox.post("saveSyncAttachment", [summaries[0].message,
                summaries[0].attachmentIDs[0], aFileMarker])
                catchTimeout(err, "alice save sync", 10000)
                testFileContent(aFileMarker, "alice save of bob attach worked", "b")
                
                
                // alice modify file
                aFileMarker.post("setString", ["c"])
                testFileContent(aFileMarker, "alice mod of bob attach before send", "c")
                catchTimeout(aliceBox.get("syncs"), "getsyncs finds change", 
                    timeoutInterval, function(checker) {
                    return checker.length > 0
                }) 
                aliceBox.post("checkSyncs", [])
            } else {println("alice did not receive mail", "red")}   
        })
        
        // ted save file
        var tedSummariesVow = tedBox.get("inboxSummaries")
        catchTimeout(tedSummariesVow, "tedSummaries having received email", 
			timeoutInterval, function(summaries) {            
            return summaries.length === 1
        })
        tedSummariesVow.when(function (summaries) {
            if (summaries.length === 1) {
                println("ted 1 mail received", "green")
                var err = tedBox.post("saveSyncAttachment", [summaries[0].message,
                    summaries[0].attachmentIDs[0], tFileMarker])
            } else {println("ted no carol mail", "red")}
            testFileContent(tFileMarker, "ted save carol attach", "carol")  
        })
        
        
        // carol queue 2 updates to ted, then commit to propagate, testing send queues
        cFileMarker.post("setString", ["carolv2"])
        carolBox.post("checkSyncs", [])
        cFileMarker.post("setString", ["carolv3"])
        carolBox.post("checkSyncs", [])
        carolBox.get("sharedFileSummaries").when(function(fileSummaries) {
            if (fileSummaries.length != 1) {
                println("carol bad file summs length", "red")
            } else {
                carolSharedFile = fileSummaries[0].sharedFile
                carolSharedFile.post("commitLocalChanges", [])
            }
        })
        
        // carol save ted2 file        
        carolBox.get("inboxSummaries").when(function(summaries) {
            if (summaries.length === 1) {
                println("carol 1 mail received", "green")
                errcatch("carol1savesync",carolBox.post("saveSyncAttachment", [summaries[0].message,
                summaries[0].attachmentIDs[0], c2FileMarker]))
                nullcatch("carolFileSums",carolBox.get("sharedFileSummaries")).when(
					function(fileSummaries) {
	                    if (fileSummaries.length != 2) {
	                        println("carol not 2 sharedfiles", "red")
	                    } else {
	                        println("carol filesummaries length 2", "green")
	                        carol2SharedFile = fileSummaries[1].sharedFile                            
	                    } 
					}
                )
            } else { println("carol no tedmail", "red")}
            testFileContent(c2FileMarker, "carol save ted attach", "ted2v1")
        })
        launch(phase3)
    }
    setTimeout(phase2, 2*timeoutInterval)
    
    // phase 3 later
    function phase3() {
        println("-- phase 3 -- ")
        var summariesVow = bobBox.get("inboxSummaries")
        catchTimeout(summariesVow, "bobMessageSummariesPhase3", timeoutInterval,
            function(summaries) {
                var result = false
                if (summaries.length != 2) {
                    println("wrong num summaries bobbox: " + summaries.length, "red")
                    result = false
                } else {
                    var update = summaries[1]
                    if (!update.isMail && !update.hasConflict && update.hasBeenUsed) {
                        println("update to bob looks good", "green")
                        result = true 
                    } else {
                        println("update to bob screwy", "red")  
                        result = false
                    } 
                    testFileContent(bFileMarker, "bobFileUpdated", "c")
                }
                return result
            }
        )
        
        // does ted have the update in his inbox?
        tedBox.get("inboxSummaries").when(function(tedSummaries) {
            if (tedSummaries.length != 2) {
                println("ted inbox not 1 mail 1 update", "red")
            }  else {
                var goodUpdate = tedSummaries[1].isMail === false &&
                    tedSummaries[1].hasConflict === false &&
                    tedSummaries[1].hasBeenUsed === false
                if (goodUpdate) {
                    println("ted update1 is good", "green")
                } else {println("tedupdate1 bad", "red") }     
            }
        }, function(err) {println("bad ted inbox", "red")})
        
        // carol send yet another update, testing receive queueing
        cFileMarker.post("setString", ["carolv4"])
        carolBox.post("checkSyncs", [])
        carolSharedFile.post("commitLocalChanges", [])
        launch(phase4)
    }
    //setTimeout(phase3, 40000)
    
    function phase4() {
        println("--")
        println("phase 4")
        tedBox.get("inboxSummaries").when(function(tedSummaries) {
            if (tedSummaries.length != 2) {
                println("ted inbox2 not 1 mail 1 update", "red")
            }  else {
                var goodUpdate = tedSummaries[1].isMail === false &&
                    tedSummaries[1].hasConflict === false &&
                    tedSummaries[1].hasBeenUsed === false
                if (goodUpdate) {
                    println("ted update2 quickcheck good", "green")
                    errcatch("tedupdate", tedSummaries[1].message.get("receivedUpdate").post(
						"update", [])).when(function(done) {
                            testFileContent(tFileMarker, "ted 3rd update", "carolv4")
                        })
                } else {println("tedupdate2 bad", "red") }     
            }
        }, function(err) {println("bad ted inbox", "red")})
        
        // carol and ted both edit ted2r, detect and resolve conflict
        t2FileMarker.post("setString", "ted2v2")
        c2FileMarker.post("setString", "carol2v2")
        tedBox.post("checkSyncs", [])
        carolBox.post("checkSyncs", [])
        carol2SharedFile.post("commitLocalChanges", [])
        ted2SharedFile.post("commitLocalChanges", [])
        launch(phase5)
    }
    //setTimeout(phase4, 55000)
    
    function phase5() {
        println("-- phase 5 -- ")
        withInSumm("carol conflict ted2", carolBox, 1, function(updateSumm) {
            var goodUpdate = !updateSumm.isMail && !hasBeenUsed && hasConflict
            if (goodUpdate) {
                println("got carol2 conflict", "green")
            } else {
                println("bad carol2 update")
            } 
        })
        
    }
    //setTimeout(phase5, 70000)
    
}        

HTML.renderers["hp.scoopfs.Main"] = {
    fill: function (value) {
        document.title = 'Scoopfs Test Main';
        exercise()
    }
};

HTML.renderers["hp.scoopfs.MailboxX"] = {
    fill: function(value) {
        showMailbox()
        //document.title = "Scoopfs Mailbox"
        //appendText("In Mailbox, where is my cool user interface?")
    }
};


